﻿using Microsoft.Office.Interop.Outlook;
using System;
using System.Windows.Forms;

namespace TestProject
{
    /// <summary>
    /// 커스텀 애드인
    /// </summary>
    public partial class CustomAddIn
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region 커스텀 애드인 시작시 처리하기 - CustomAddIn_Startup(sender, e)

        /// <summary>
        /// 커스텀 애드인 시작시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void CustomAddIn_Startup(object sender, EventArgs e)
        {
            SendMail();
        }

        #endregion
        #region 커스텀 애드인 셧다운시 처리하기 - CustomAddIn_Shutdown(sender, e)

        /// <summary>
        /// 커스텀 애드인 셧다운시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void CustomAddIn_Shutdown(object sender, EventArgs e)
        {
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Function

        #region VSTO에서 생성한 코드

        /// <summary>
        /// 디자이너 지원에 필요한 메서드입니다. 
        /// 이 메서드의 내용을 코드 편집기로 수정하지 마세요.
        /// </summary>
        private void InternalStartup()
        {
            this.Startup  += new System.EventHandler(CustomAddIn_Startup );
            this.Shutdown += new System.EventHandler(CustomAddIn_Shutdown);
        }

        #endregion

        #region 메일 항목 생성하기 - CreateMailItem(mailAddress, subject, content)

        /// <summary>
        /// 메일 항목 생성하기
        /// </summary>
        /// <param name="mailAddress">메일 주소</param>
        /// <param name="subject">제목</param>
        /// <param name="content">내용</param>
        private void CreateMailItem(string mailAddress, string subject, string content)
        {
            MailItem mailItem = (MailItem)Application.CreateItem(OlItemType.olMailItem);

            mailItem.Subject    = subject;
            mailItem.To         = mailAddress;
            mailItem.Body       = content;
            mailItem.Importance = OlImportance.olImportanceLow;

            ((_MailItem)mailItem).Send();
        }

        #endregion
        #region 메일 보내기 - SendMail()

        /// <summary>
        /// 메일 보내기
        /// </summary>
        private void SendMail()
        {
            MAPIFolder contactsFolder = (MAPIFolder)Application.ActiveExplorer().Session.GetDefaultFolder(OlDefaultFolders.olFolderContacts);

            string subject = "Meeting has been rescheduled.";
            string content = "Meeting is one hour later.";

            foreach(ContactItem contactItem in contactsFolder.Items)
            {
                if(contactItem.Email1Address.Contains("example.com"))
                {
                    CreateMailItem(contactItem.Email1Address, subject, content);
                }
            }
        }

        #endregion
    }
}